#pragma once

#include <queue>

#include "thread_message.h"

class CORE_API thread_message_hub {
public:
    // template<typename T, typename ...Args>
    // void push_message(Args&&... args) {
    //     T* message = obj_mempool<T>::alloc(std::forward<Args>(args)...);
    //     push_message(message);
    // }
    // template<typename T>
    // void push_message() {
    //     T* message = obj_mempool<T>::alloc();
    //     push_message(message);
    // }
    void push_message(const std::function<void()>& func) {
        auto* message = new lamba_thread_message(func);
        push_message(message);
    }
    void process_messages();
private:
    void push_message(lamba_thread_message* message) {
        messages_.push(message);
    }
    std::queue<lamba_thread_message*> messages_;
};
